#ifndef MATRICE2DIM_H
#define MATRICE2DIM_H

const int DIMMAX = 50;
const int ELEMDEFAULT=0.0;
typedef int tipoelem;  // matrice di interi
typedef int indice;

class Matrice2dim {
public:
   Matrice2dim(indice, indice);
   ~Matrice2dim();
   tipoelem leggielemento(indice,indice);
   void scrivielemento(indice,indice,tipoelem);
   void stampa() const;
   void stampagrafica() const;
   Matrice2dim somma(Matrice2dim);
   Matrice2dim prodotto(Matrice2dim); // moltiplica A x B, A  la matrice su cui il metodo  invocato;
   indice getnrighe();
   indice getncolonne();
private:
   indice numerorighe; // elementi da 1 a DIMMAX
   indice numerocolonne; // elementi da 1 a DIMAX
   tipoelem elem[DIMMAX][DIMMAX];
   bool controllaindici(indice,indice);
   bool controllalimite(indice);
   void tipomatrice();
};

#endif
