#include <iostream>
using namespace std;
#include "Matrice2dimT.h"


template <class T, int max> Matrice2dimT <T, max> ::Matrice2dimT(indice nrighe, indice ncolonne)
{
//   if (nrighe<=DIMR ? numerorighe=nrighe : numerorighe=DIMR);
//   if (ncolonne<=DIMC ? numerocolonne=ncolonne : numerocolonne=DIMC);
   tipomatrice();
   if (controllalimite(nrighe) && controllalimite(ncolonne)) {
   numerorighe=nrighe;
   numerocolonne=ncolonne;
   }
   else
      cout << "Almeno uno degli indici fuori limite" << endl;
}

template <class T, int max> Matrice2dimT <T, max> ::~Matrice2dimT()
{}

template <class T, int max> T Matrice2dimT <T, max> ::leggielemento(indice riga, indice colonna)
{
   if (controllaindici(riga,colonna)) 
      return elem[riga-1][colonna-1];
   else cout << "Accesso non valido" << endl;
}

template <class T, int max> indice Matrice2dimT <T, max> ::getnrighe()
{
 return numerorighe;
}

template <class T, int max> indice Matrice2dimT <T, max> ::getncolonne()
{
 return numerocolonne;
}

template <class T, int max> void Matrice2dimT <T, max> ::scrivielemento(indice riga,indice colonna, T e)
{                           
      if (controllaindici(riga,colonna)) 
         elem[riga-1][colonna-1]=e;
      else cout << "Accesso non valido" << endl;
      
}

template <class T, int max> Matrice2dimT<T, max> Matrice2dimT<T, max>::somma(Matrice2dimT matrix)
{
   if (numerorighe==matrix.getnrighe() && numerocolonne==matrix.getncolonne())                           
   {
      Matrice2dimT<T, max> risultato(numerorighe,numerocolonne);
      for (indice i=1; i<=numerorighe;i++)
          for (indice j=1; j<=numerocolonne;j++)
          {
              risultato.scrivielemento(i,j,leggielemento(i,j)+matrix.leggielemento(i,j));
          }
      return risultato;
   }                                     
   else cout << "Somma non possibile!" << endl;
}

template <class T, int max>  Matrice2dimT<T, max> Matrice2dimT<T, max>::prodotto(Matrice2dimT matrix)
{
   if (numerocolonne==matrix.getnrighe())                           
   {
      Matrice2dimT risultato(numerorighe,matrix.getncolonne());
      for (indice i=1; i<=numerorighe;i++)
          for (indice j=1; j<=matrix.getncolonne();j++)
          {
              T somma=0;
              for (indice k=1; k<=numerocolonne;k++)
                  somma=somma+leggielemento(i,k)*matrix.leggielemento(k,j);
              risultato.scrivielemento(i,j,somma);                     
          }
      
      return risultato;
   }                                     
   else cout << "Prodotto non possibile!" << endl;
}

template <class T, int max> void Matrice2dimT <T, max> ::stampa() const
{
   for (indice i=1; i<=numerorighe;i++)
       for (indice j=1; j<=numerocolonne;j++)
       {
           cout << "Elemento[" << i <<"]" << "[" << j << "]= " << elem[i-1][j-1] << endl; 
       }
}

template <class T, int max> void Matrice2dimT <T, max> ::stampagrafica() const
{
   for (indice i=1; i<=numerorighe;i++)
   {
       for (indice j=1; j<=numerocolonne;j++)
       {
           cout << elem[i-1][j-1] << " "; 
       }
       cout << '\n';
   } 
}


template <class T, int max> bool Matrice2dimT<T, max>::controllalimite(indice i)
{
         return (i>=1 && i<max);       
}

template <class T, int max> bool Matrice2dimT<T, max>::controllaindici(indice riga, indice colonna)
{
         return (riga>=1 && riga<=numerorighe && colonna>=1 && colonna<=numerocolonne);       
}

template <class T, int max> void Matrice2dimT<T, max>::tipomatrice()
{
         if (sizeof(T)==4)
            cout << "matrice di interi" << endl;
         else
         {
             if (sizeof(T)==8)
               cout << "matrice di reali" << endl;
         }
}
