#include <iostream>
using namespace std;
#include "Matrice2dim.h"


Matrice2dim::Matrice2dim(indice nrighe, indice ncolonne)
{
//   if (nrighe<=DIMR ? numerorighe=nrighe : numerorighe=DIMR);
//   if (ncolonne<=DIMC ? numerocolonne=ncolonne : numerocolonne=DIMC);
   tipomatrice();
   if (controllalimite(nrighe) && controllalimite(ncolonne)) {
   numerorighe=nrighe;
   numerocolonne=ncolonne;
   for (indice i=0; i<numerorighe;i++)
      for (indice j=0; j<numerocolonne;j++)
      {
          elem[i][j]=ELEMDEFAULT;
        //  cout << "Settato elemento " << i << "," << j << "a " << ELEMDEFAULT << endl;
      }
   }
   else
      cout << "Almeno uno degli indici fuori limite" << endl;
}

Matrice2dim::~Matrice2dim()
{}

tipoelem Matrice2dim::leggielemento(indice riga, indice colonna)
{
   if (controllaindici(riga,colonna)) 
      return elem[riga-1][colonna-1];
   else cout << "Accesso non valido" << endl;
}

indice Matrice2dim::getnrighe()
{
 return numerorighe;
}

indice Matrice2dim::getncolonne()
{
 return numerocolonne;
}

void Matrice2dim::scrivielemento(indice riga,indice colonna, tipoelem e)
{                           
      if (controllaindici(riga,colonna)) 
         elem[riga-1][colonna-1]=e;
      else cout << "Accesso non valido" << endl;
      
}

Matrice2dim Matrice2dim::somma(Matrice2dim matrix)
{
   if (numerorighe==matrix.getnrighe() && numerocolonne==matrix.getncolonne())                           
   {
      Matrice2dim risultato(numerorighe,numerocolonne);
      for (indice i=1; i<=numerorighe;i++)
          for (indice j=1; j<=numerocolonne;j++)
          {
              risultato.scrivielemento(i,j,leggielemento(i,j)+matrix.leggielemento(i,j));
          }
      return risultato;
   }                                     
   else cout << "Somma non possibile!" << endl;
}

Matrice2dim Matrice2dim::prodotto(Matrice2dim matrix)
{
   if (numerocolonne==matrix.getnrighe())                           
   {
      Matrice2dim risultato(numerorighe,matrix.getncolonne());
      for (indice i=1; i<=numerorighe;i++)
          for (indice j=1; j<=matrix.getncolonne();j++)
          {
              tipoelem somma=ELEMDEFAULT;
              for (indice k=1; k<=numerocolonne;k++)
                  somma=somma+leggielemento(i,k)*matrix.leggielemento(k,j);
              risultato.scrivielemento(i,j,somma);                     
          }
      
      return risultato;
   }                                     
   else cout << "Prodotto non possibile!" << endl;
}

void Matrice2dim::stampa() const
{
   for (indice i=1; i<=numerorighe;i++)
       for (indice j=1; j<=numerocolonne;j++)
       {
           cout << "Elemento[" << i <<"]" << "[" << j << "]= " << elem[i-1][j-1] << endl; 
       }
}

void Matrice2dim::stampagrafica() const
{
   for (indice i=1; i<=numerorighe;i++)
   {
       for (indice j=1; j<=numerocolonne;j++)
       {
           cout << elem[i-1][j-1] << " "; 
       }
       cout << '\n';
   } 
}


bool Matrice2dim::controllalimite(indice i)
{
         return (i>=1 && i<DIMMAX);       
}

bool Matrice2dim::controllaindici(indice riga, indice colonna)
{
         return (riga>=1 && riga<=numerorighe && colonna>=1 && colonna<=numerocolonne);       
}

void Matrice2dim::tipomatrice()
{
         if (sizeof(ELEMDEFAULT)==4)
            cout << "matrice di interi" << endl;
         else
         {
             if (sizeof(ELEMDEFAULT)==8)
               cout << "matrice di reali" << endl;
         }
}

